/* $Id$

   Beam Backup - backup vital data to another PalmOS handheld.
   Copyright (C) 2001 Fraser McCrossan http://www.joat.ca

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA
*/

/* set error levels */
#define ERROR_CHECK_LEVEL ERROR_CHECK_FULL
#define UNUSED  __attribute__((__unused__))

/* my creator ID */
#define appSbl 'SBuL'
#define versionSbl 0x0001

#define MaxApps ((LastApp) - (FirstApp) + 1) /* applications we can launch 
						from one button */

#define NumButtons 4

/* ticks between scrolls */
#define DEFAULTDELAY 32

#define NOLASTBUTTON -1

typedef struct {
  Char apps[NumButtons][MaxApps][dmDBNameLength]; /* the names of the
                                                     applications we
                                                     are launching */
  Int16 lastButtonPressed;
} sblpreftype;

typedef struct {
  Char name[dmDBNameLength];
} app_entry;

typedef struct {
  UInt16 num_apps;
  MemHandle apps;
} app_list;

extern UInt32 rom_version;
extern Boolean on_poser;

extern sblpreftype prefs; /* every source file gets to see this */

/* function prototypes */
Boolean MainFormHandler();
Boolean AboutFormHandler();
void GetAllDatabases();
void ClearAllDatabases();
Boolean PickForm_Run(Char *);
void DrawListItem(Int16, RectangleType *, Char **);
void FindFirstButton();
