#!/usr/bin/wish
# $Id: toplucker.tcl,v 1.14 2004/01/17 22:13:40 arpruss Exp $
#
proc mainline {} {
       create_widgets
}

proc go { } {
    global bitmapVersions
    global theOutFileName
    global theDBName
    global theSize
    global styleId
    global orientId
    global fontPrefixes
    global systemSelection
    global systemList
    global fontConvTypes
    global fontList
    global theFileNames
    global orientList
    global orientSelection
    global argv0
    global aaFonts
    global forceNBS
    global disableKerning
    global forceEven
    global .frmEncoding.box

    if {[.frmEncoding.box curselection] == ""} {
         set encoding "palmLatin"
    } {
         set encoding [.frmEncoding.box get [.frmEncoding.box curselection]]
    }

    set progDir [file dirname $argv0]
    set workingDirExt "_tempDir"
    set toText "$progDir/topalmtext"
    set toGray "$progDir/togray"
    set fontConv "$progDir/fontconv"
    set toPrc "$progDir/toprc"
    set workingDir "$theOutFileName$workingDirExt"
    set bitDepth 4

    set activeFontList ""

    foreach font $fontList {
        if {$theFileNames($font) != ""} {
            lappend activeFontList $font
        }
    }
    if {$activeFontList == ""} {
        tk_messageBox -title "Error" -message "You need to specify at least one font."
        return
    }
    set activeSystemList ""
    foreach system $systemList {
        if {$systemSelection($system)} {
            lappend activeSystemList $system
        }
    }
    if {$activeSystemList == ""} {
        tk_messageBox -title "Error" -message "You need to specify at least one system."
        return
    }
    set activeOrientList ""
    foreach orient $orientList {
        if {$orientSelection($orient)} {
            lappend activeOrientList $orient
        }
    }
    if {$activeOrientList == ""} {
        tk_messageBox -title "Error" -message "You need to specify at least one orientation."
        return
    }
    if {$theOutFileName == ""} {
        tk_messageBox -title "Error" -message "You need to specify the output filename."
        return
    }
    if {$theDBName == ""} {
        tk_messageBox -title "Error" -message "You need to specify the Palm database name."
        return
    }

    file mkdir $workingDir
    set toDelete [glob -nocomplain -path "$workingDir/" *.bin]
    if {$toDelete != ""} {
        eval file delete $toDelete
    }

    if {$aaFonts} {
        set gray "gray"
    } {
        set gray ""
    }
    if {$forceNBS} {
       set opt1 "-f"
    } {
       set opt1 "-f-"
    }
    if {$disableKerning} {
       set opt2 "-n"
    } {
       set opt2 "-n-"
    }
    if {$forceEven} {
       set opt3 "-e"
    } {
       set opt3 "-e-"
    }
    foreach font $activeFontList {
             exec $toText -$encoding $opt1 $opt2 $opt3 $theFileNames($font) $theSize($font) $gray > "$workingDir/$font.fonttext"
         if {! $aaFonts} {
             foreach system $activeSystemList {
                 exec $fontConv "$workingDir/$font.fonttext" $fontConvTypes($system) "$workingDir/$fontPrefixes($system)$styleId($font).bin"
             }
         }
    }
    if {$aaFonts} {
        set commandLine "-W$workingDir/"
        foreach system $activeSystemList {
            foreach font $activeFontList {
                lappend commandLine $fontPrefixes($system)$styleId($font)
                lappend commandLine "$workingDir/$font.fonttext"
                foreach orient $activeOrientList {
                    lappend commandLine "G$orientId($orient)$bitmapVersions($system)$bitDepth"
                }
                lappend commandLine "-"
            }
        }
        eval exec $toGray $commandLine
    }


    set commandLine [list "$theOutFileName" "$theDBName" Font Plkr]
    set commandLine [concat $commandLine [glob -path "$workingDir/" *.bin]]

    eval exec $toPrc $commandLine
    set toDelete [glob -nocomplain -path "$workingDir/" *.bin *.fonttext]
    if {$toDelete != ""} {
        eval file delete $toDelete
    }
    eval file delete "$workingDir"
    tk_messageBox -title "Done!" -message "Produced $theOutFileName."
}

proc getOutFileName { } {
    global theOutFileName
    global theDBName
    set types {
        {{Palm Resource Database}   {.prc}        }
    }
    set theOutFileName [tk_getSaveFile -defaultextension prc -filetypes $types]
    if {$theDBName == ""} then {
        set theDBName [file rootname [file tail $theOutFileName]]
    }
}

proc insertFileName { font } {
    global theFileNames
    global biggerVersion
    global smallerVersion
    set theFileNames($font) [tk_getOpenFile]
    if {$biggerVersion($font) != "" && $theFileNames($biggerVersion($font)) == ""} then {
        set theFileNames($biggerVersion($font)) $theFileNames($font)
    }
    if {$smallerVersion($font) != "" && $theFileNames($smallerVersion($font)) == ""} then {
        set theFileNames($smallerVersion($font)) $theFileNames($font)
    }
}


proc add_font_record { font name size id bigger smaller } {
    global theFileNames
    global theSize
    global styleId
    global biggerVersion
    global smallerVersion
    global fontList
    lappend fontList $font
    set styleId($font) $id
    set biggerVersion($font) $bigger
    set smallerVersion($font) $smaller
    set theSize($font) $size
    frame .frm($font)
    label .frm($font).name -text "$name: " -width 12
    entry .frm($font).fileName -width 45 -textvariable theFileNames($font)
    button .frm($font).browse -text "Browse..." -command "insertFileName $font"
    label .frm($font).sizeLabel -text "Size"
    entry .frm($font).size -width 5 -textvariable theSize($font)
    pack .frm($font)
    grid .frm($font).name .frm($font).fileName .frm($font).browse .frm($font).sizeLabel .frm($font).size
}

proc add_system { form system name fontPrefix bitmapVersion fontConvType } {
    global fontPrefixes
    global systemSelection
    global systemList
    global bitmapVersions
    global fontConvTypes
    lappend systemList $system
    set fontPrefixes($system) $fontPrefix
    set bitmapVersions($system) $bitmapVersion
    set fontConvTypes($system) $fontConvType
    checkbutton $form -text "$name" -variable systemSelection($system)
}

proc add_orient { form orient name id default } {
    global orientSelection
    global orientList
    global orientId
    lappend orientList $orient
    set orientId($orient) $id
    set orientSelection($orient) $default
    checkbutton $form -text "$name" -variable orientSelection($orient)
}

proc create_widgets {} {
    global theOutFileName
    global aaFonts
    global theDBName
    global forceNBS
    global forceEven
    global disableKerning
    global .frmEncoding.box
    add_font_record stdFont        "Standard"    18 "20" "largeFont" "narrow"
    add_font_record boldFont       "Bold"        18 "21" "largeBoldFont" ""
    add_font_record largeFont      "Large"       21 "22" "" ""
    add_font_record largeBoldFont  "Large bold"  21 "23" "" ""
    add_font_record narrow         "Narrow"      17 "24" "" ""
    add_font_record fixed          "Fixed width" 18 "26" "" ""
    add_font_record IstdFont        "Italic"             18 "60" "IlargeFont" "Inarrow"
    add_font_record IboldFont       "Italic bold"        18 "61" "IlargeBoldFont" ""
    add_font_record IlargeFont      "Italic large"       21 "62" "" ""
    add_font_record IlargeBoldFont  "Italic large bold"  21 "63" "" ""
    add_font_record Inarrow         "Italic narrow"      17 "64" "" ""
    add_font_record Ifixed          "Italic fixed width" 18 "66" "" ""
    frame .frmOutput
    label .frmOutput.fileNameLabel -text "Output filename: "
    entry .frmOutput.outFileName -width 45 -textvariable theOutFileName
    label .frmOutput.dbNameLabel -text "Palm name: "
    button .frmOutput.browse -text "Browse..." -command "getOutFileName"
    entry .frmOutput.dbName -width 30 -textvariable theDBName
    pack .frmOutput
    grid .frmOutput.fileNameLabel .frmOutput.outFileName .frmOutput.browse
    grid .frmOutput.dbNameLabel .frmOutput.dbName

    frame .frmSystems
    label .frmSystems.label -text "Systems: "
    add_system .frmSystems.loRes loRes "Standard resolution" "NFNT02" 1 "l"
    add_system .frmSystems.sony sony "Sony high resolution (pre-OS5)" "NFNT04" 1 "l"
    add_system .frmSystems.os5 os5 "OS5 high resolution" "nfnt06" 3 "H"
    pack .frmSystems
    grid .frmSystems.label .frmSystems.loRes .frmSystems.sony .frmSystems.os5

    frame .frmOrient
    label .frmOrient.label -text "Orientation (only if anti-aliased): "
    add_orient .frmOrient.normal normal "Normal" "U" 1
    add_orient .frmOrient.right right "Clockwise" "R" 0
    add_orient .frmOrient.left left "Counterclockwise" "L" 0
    pack .frmOrient
    grid .frmOrient.label .frmOrient.normal .frmOrient.right .frmOrient.left

    frame .frmGenerate
    label .frmGenerate.label -text "Font generation: "
    checkbutton .frmGenerate.antiAlias -text "Anti-aliasing" -variable aaFonts
    checkbutton .frmGenerate.disableKerning -text "Disable kerning" -variable disableKerning
    checkbutton .frmGenerate.forceNBS -text "Force some Latin 1 chars" -variable forceNBS
    checkbutton .frmGenerate.forceEven -text "Force even width" -variable forceEven
    pack .frmGenerate
    grid .frmGenerate.label .frmGenerate.antiAlias .frmGenerate.forceNBS .frmGenerate.disableKerning .frmGenerate.forceEven
    set disableKerning 0
    set forceNBS       0
    set forceEven      0

    frame .frmEncoding
    label .frmEncoding.label -text "Encoding: "

    listbox .frmEncoding.box -selectmode single -height 5 -yscroll ".frmEncoding.scroll set"
    scrollbar .frmEncoding.scroll -command ".frmEncoding.box yview"
    .frmEncoding.box insert 0 \
                  "none" "palmLatin" "CP1250" "CP1251" "CP1252" "CP1253" "CP1254" "CP1255" \
                  "CP1256" "CP1257" "CP1258" "CP874" "ISO8859_1" "ISO8859_10" "ISO8859_11" \
                  "ISO8859_13" "ISO8859_14" "ISO8859_15" "ISO8859_16" "ISO8859_2" "ISO8859_3" \
                  "ISO8859_4" "ISO8859_5" "ISO8859_6" "ISO8859_7" "ISO8859_8" "ISO8859_9" "KOI8R"
    pack .frmEncoding
    grid .frmEncoding.label -row 0 -column 0
    grid .frmEncoding.box -row 0 -column 1 -sticky news
    grid .frmEncoding.scroll -row 0 -column 2 -sticky news
    .frmEncoding.box selection set 1

    frame .frmCommands
    button .frmCommands.go -text "Go!" -command go
    button .frmCommands.cancel -text "Exit" -command exit
    pack .frmCommands
    grid .frmCommands.go .frmCommands.cancel
}

mainline
